// (c) Copyright Microsoft Corporation.
// This source is subject to the Microsoft Permissive License.
// See http://www.microsoft.com/resources/sharedsource/licensingbasics/sharedsourcelicenses.mspx.
// All other rights reserved.


using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Collections.Generic;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class ReorderList : System.Web.UI.Page
{

    protected object SimpleDataSource
    {
        get
        {
            if (ViewState["Simple"] == null)
            {
                ViewState["Simple"] = new string[] { "A", "B", "C", "D", "E" };
            }
            return ViewState["Simple"];
        }
    }

    protected object IListDataSource
    {
        get
        {
            if (ViewState["IList"] == null) {
              
                List<Person> people = new List<Person>();

                people.Add(new Person("Shawn", 3036));
                people.Add(new Person("David", 3017));
                people.Add(new Person("Ted", 3027));
                ViewState["IList"] = people;
            } 
            return ViewState["IList"];
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        ReorderList2.DataSource = SimpleDataSource;
        ReorderList2.DataBind();

        ReorderList3.DataSource = IListDataSource;
        ReorderList3.DataBind();
        ReorderList3.ItemReorder += new EventHandler<AjaxControlToolkit.ReorderListItemReorderEventArgs>(ReorderList3_ItemReorder);
        
    }

    void ReorderList3_ItemReorder(object sender, AjaxControlToolkit.ReorderListItemReorderEventArgs e) {
        TrackViewState();
  
        ReorderList3.DataSource = IListDataSource;
        ReorderList3.DataBind();
    }

    [Serializable]
    public class Person
    {
        private string _name;

        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }
        private int _office;

        public int Office
        {
            get { return _office; }
            set { _office = value; }
        }

        public Person()
        {
        }

        public Person(string n, int a)
        {
            _name = n;
            _office = a;
        }

        public override string ToString()
        {
            return String.Format("{0}, {1}", Name, Office);
        }

    }

    
}
